program FowlDemo;
{$MODE OBJFPC}{$H+}
// Define this to load the UI from the fowldemo.ui file:
{ $DEFINE LOAD_UI_FROM_FILE}
uses FObjects;
const
  UIStreamFile = 'fowldemo.ui';

type
  { Pointer to objects }
  PDemoMainWin = ^TDemoMainWin;

  { Main window for the demo }
  TDemoMainWin = object(TWindow)
    constructor Init;
    procedure SetupWindow; virtual;
    function ProcessNotification(Child: PWindowsObject; NotifyCode: Integer): Boolean; virtual;
    function ProcessCommand(Command: Integer): Boolean; virtual;
  end;

  { Demo application type }
  TDemoApp = object(TApplication)
    procedure InitMainWindow; virtual;
  end;

const
  { Stream record for TDemoMainWin }
  RDemoMainWin: TStreamRec = (
    ObjType: ot_First;
    VmtLink: Ofs(TypeOf(TDemoMainWin)^);
    Load: @TWindow.Load;
    Store: @TWindow.Store;
    Next: nil);

{ TDemoMainWin }
constructor TDemoMainWin.Init;
var
  MenuBar, FileMenu, SubMenu, HelpMenu: PMenu;
  Button: PButton;
  Static: PStatic;
  Scroll: PScrollBar;
  Editor: PEdit;
  Listen: PListBox;
  Combos: PComboBox;
  Groups: PGroupBox;
  Checki: PCheckBox;
  Radion: PRadioButton;
begin
  inherited Init(nil, 'Fowl Demo');
  New(MenuBar, Init);
  New(FileMenu, Init);
  FileMenu^.AppendMenu('&An item', 100, it_Normal, nil);
  FileMenu^.AppendMenu('Another &item', 101, it_Normal, nil);
  FileMenu^.AppendSeparator;
  New(SubMenu, Init);
  SubMenu^.AppendMenu('Foo', 102, it_Normal, nil);
  SubMenu^.AppendMenu('Bar', 103, it_Normal, nil);
  FileMenu^.AppendMenu('&Sub Menu', id_None, it_SubMenu, SubMenu);
  FileMenu^.AppendSeparator;
  FileMenu^.AppendMenu('E&xit', 199, it_Normal, nil);
  MenuBar^.AppendMenu('&File', id_None, it_SubMenu, FileMenu);
  New(HelpMenu, Init);
  HelpMenu^.AppendMenu('&About...', 999, it_Normal, nil);
  MenuBar^.AppendMenu('&Help', id_None, it_SubMenu, HelpMenu);
  SetMenu(MenuBar);
  New(Button, Init(@Self, 100, 'Test Button', 10, 10, 100, 25, False));
  New(Button, Init(@Self, 101, 'Another Button', 10, 40, 100, 25, False));
  New(Static, Init(@Self, 102, 'Some text', 10, 70, 100, 25));
  New(Scroll, Init(@Self, 103, 10, 100, 100, 16, True));
  New(Editor, Init(@Self, 104, '', 10, 120, 100, 21, []));
  New(Editor, Init(@Self, 105, 'La Memo', 120, 10, 150, 100, [eoMultiline, eoWordWrap]));
  New(Listen, Init(@Self, 106, 280, 10, 150, 100, []));
  New(Combos, Init(@Self, 107, 120, 120, 150, 250, []));
  New(Combos, Init(@Self, 108, 280, 120, 150, 250, [coDropDownList]));
  New(Groups, Init(@Self, 109, 'Some Controls', 10, 150, 150, 100));
  New(Checki, Init(Groups, 110, 'Checkbox One', 10, 20, 130, 16, []));
  New(Checki, Init(Groups, 111, 'Checkbox Two', 10, 40, 130, 16, [coAutoCheck]));
  New(Checki, Init(Groups, 112, 'Checkbox 3', 10, 60, 130, 16, [co3State]));
  New(Checki, Init(Groups, 113, 'Checkbox IV', 10, 80, 130, 16, [coAutoCheck, co3State]));
  New(Groups, Init(@Self, 114, 'Some Radios', 180, 150, 150, 100));
  New(Radion, Init(Groups, 115, 'Choice One', 10, 20, 130, 16));
  New(Radion, Init(Groups, 116, 'Choice Two', 10, 40, 130, 16));
  New(Radion, Init(Groups, 117, 'Choice 3', 10, 60, 130, 16));
  New(Radion, Init(Groups, 118, 'Choice IV', 10, 80, 130, 16));
end;

procedure TDemoMainWin.SetupWindow;
begin
  inherited SetupWindow;
  PComboBox(ChildWithId(107))^.AddString('Foo');
  PComboBox(ChildWithId(107))^.AddString('Bar');
  PComboBox(ChildWithId(107))^.AddString('Moo');
  PComboBox(ChildWithId(108))^.AddString('Something');
  PComboBox(ChildWithId(108))^.AddString('Something Else');
  PComboBox(ChildWithId(108))^.AddString('Something New');
  PComboBox(ChildWithId(108))^.AddString('Nothing');
end;

function TDemoMainWin.ProcessNotification(Child: PWindowsObject; NotifyCode: Integer): Boolean;
var
  F: TFileStream;
  S: string;
begin
  if NotifyCode=cn_Clicked then begin
    if Child^.GetId=100 then begin
      PListBox(ChildWithId(106))^.AddString(ChildWithId(104)^.GetText);
    end;
    if Child^.GetId=101 then begin
      F.Init(UIStreamFile, stCreate);
      F.Put(Application^.MainWindow);
      F.Done;
    end;
    if Child^.GetId=112 then begin
      SetText('Check clicked');
      PCheckBox(Child)^.Toggle;
    end;
  end;
  if NotifyCode=cn_Changed then begin
    if Child^.GetId=103 then begin
      Str(PScrollBar(Child)^.GetPosition, S);
      ChildWithId(102)^.SetText(S);
    end;
    if Child^.GetId=104 then begin
      SetText('Editor changed');
    end;
    if Child^.GetId=105 then begin
      SetText('Memo changed');
    end;
  end;
  Result:=False;
end;

function TDemoMainWin.ProcessCommand(Command: Integer): Boolean;
var
  S: string;
begin
  Str(Command, S);
  SetText('Got command ' + S);
  Result:=False;
end;

{ TDemoApp }
procedure TDemoApp.InitMainWindow;
{$IFDEF LOAD_UI_FROM_FILE}
var
  F: TFileStream;
{$ENDIF}
begin
  {$IFDEF LOAD_UI_FROM_FILE}
  F.Init(UIStreamFile, stOpenRead);
  MainWindow:=PWindowsObject(F.Get);
  F.Done;
  {$ELSE}
  MainWindow:=New(PDemoMainWin, Init);
  {$ENDIF}
end;

var
  DemoApp: TDemoApp;
begin
  RegisterType(RDemoMainWin);
  DemoApp.Init('Fowl Demo');
  DemoApp.Run;
  DemoApp.Done;
end.
